

#include <stdarg.h>

void pr(char *fmt, ... ){
        char buf[128]; // resulting string limited to 128 chars
        va_list args;
        va_start (args, fmt );
        vsnprintf(buf, 128, fmt, args);
        va_end (args);
        Serial.println(buf);

}


#define SENSOR_POWER_PIN 2
#define SENSOR_OUTPUT_PIN A1
#define FAN_POWER_PIN 11

int state;

#define STATE_OFF 0
#define STATE_ON  1

void setup(void)
{
 Serial.begin(9600);
 while (!Serial) { ; /* wait for serial port to connect. Needed for native USB */}

 pinMode(SENSOR_POWER_PIN, OUTPUT);
 digitalWrite(SENSOR_POWER_PIN, HIGH); 

 pinMode(FAN_POWER_PIN, OUTPUT);  
 digitalWrite(FAN_POWER_PIN,0);

 state=STATE_OFF;
}

#define THRESHOLD 125
#define RUNONTIME 10000
#define WARMUPCOUNT 20

unsigned long ontime;


void loop(void)
{
 static int onval;
 static int offval;
 static int ledon=1;
 static int warmupcount=0;
 
 
 if(ledon^=1)
 {
  offval=1023-analogRead(SENSOR_OUTPUT_PIN);  // make bigger brighter
  digitalWrite(SENSOR_POWER_PIN, HIGH); 
 }
 else
 {
  onval=1023-analogRead(SENSOR_OUTPUT_PIN); // make bigger brighter
  digitalWrite(SENSOR_POWER_PIN, LOW); 
 }


 if(warmupcount<WARMUPCOUNT)
 {
  warmupcount++;
 }
 else
 if(!ledon)
 {
//  pr("test");
  if((onval-offval)<THRESHOLD)
  {
//    pr("trigger");
   if(state==STATE_OFF)
   {
    digitalWrite(FAN_POWER_PIN,1); //pr("fan on");
    state=STATE_ON;
   }
   ontime=millis();
  }
  else
  {
   if(state==STATE_ON)
   {
    if((millis()-ontime)>RUNONTIME)
    {
     digitalWrite(FAN_POWER_PIN,0); //pr("fan off");
     state=STATE_OFF;
    }
   } 
  }
 }
 
// pr("onval %d offval %d delta=%d",onval,offval,onval-offval);
 delay(1000);
}

